<?php

namespace Ourgold\Exchange;

use Exception;
use Illuminate\Support\ServiceProvider;
use Ourgold\Exchange\Commands\ExecuteExchangeQueue;

class ExchangeServiceProvider extends ServiceProvider
{
    /**
     * Bootstrap services.
     *
     * @return void
     * @throws Exception
     */
    public function boot()
    {
        $this->mergeConfigFrom(__DIR__ . '/config/config.php', 'exchange');
        $this->loadMigrationsFrom(__DIR__ . '/application/database/migrations');
        $this->commands([ExecuteExchangeQueue::class]);

        if ($this->app->runningInConsole()) {

            $this->publishes(
                [
                    __DIR__ . '/config/config.php' => config_path('exchange.php'),
                ],
                'config'
            );

        }
    }

    /**
     * @return void
     */
    public function register()
    {
    }
}
