<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
use Symfony\Component\Console\Output\ConsoleOutput;
use Symfony\Component\Console\Output\OutputInterface;

class CreateExchangeQueueTable extends Migration
{
//    use InteractsWithIO;
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {

        /** @var string $tableName */
        $tableName = config('exchange.table_name');

        if (Schema::hasTable($tableName)) {

            $msg = "$tableName already exists, skipping migration...";

            if (app()->runningInConsole()) {
                $console = new ConsoleOutput(OutputInterface::VERBOSITY_NORMAL, true);
                $console->writeln($msg);
            }

            \Log::warning($msg);

            return;
        }

        Schema::create($tableName, function (Blueprint $table) {
            $table->increments('id');
            $table->json('data')
                ->comment('Данные');
            $table->unsignedTinyInteger('status')
                ->comment('Статус обмена');
            $table->text('error')
                ->default('')
                ->comment('Ошибка обмена');

            $table->timestamps(); // created_at, updated_at
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists(config('exchange.table_name'));
    }
}
